package com.test;

import java.io.Serializable;
import java.util.Properties;

import javax.naming.Context;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueReceiver;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.QueueSender;
import javax.jms.DeliveryMode;
import javax.jms.QueueSession;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import org.hornetq.jms.client.HornetQQueue;


public class Sender implements  MessageListener {
     
	public static Context getInitialContext()throws javax.naming.NamingException {
		Properties p = new Properties();
		p.put("java.naming.factory.initial","org.jnp.interfaces.NamingContextFactory");
		p.put(Context.PROVIDER_URL, "jnp://127.0.0.1:1099");
		return new javax.naming.InitialContext(p);
	}

	
	public void getMessage() {
		try {
			Context ctx = getInitialContext();

			// lookup the queue object
			Queue queue = (HornetQQueue) ctx.lookup("queue/Myqueue1");
			// lookup the queue connection factory
			QueueConnectionFactory connFactory = (QueueConnectionFactory) ctx
					.lookup("/ConnectionFactory");
			// create a queue connection
			QueueConnection queueConn = connFactory.createQueueConnection();
			// create a queue session
			QueueSession queueSession = queueConn.createQueueSession(true,
					Session.AUTO_ACKNOWLEDGE);
			// create a queue sender
			QueueSender queueSender = queueSession.createSender(queue);
			
			TestClass messageData = new TestClass();
			messageData.setEid(123);
			messageData.setEname("abc");
			ObjectMessage message =  queueSession.createObjectMessage();
			
			if (messageData instanceof TestClass) {
			
			message.setObject((Serializable)messageData);   
			
			queueSender.send(message);
			
			}
			QueueReceiver queueReceiver = queueSession.createReceiver(queue);
			//AsynReceiver listener = new AsynReceiver();
			queueReceiver.setMessageListener(this);
			// start the connection
			queueConn.start();
			// close the queue connection
			queueConn.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
		}

	}
	
	public void onMessage(Message queuemessage) {
        try {
            if (queuemessage instanceof ObjectMessage) {
            	ObjectMessage Objmsg = (ObjectMessage) queuemessage;
            	//Object body = ((ObjectMessage)queuemessage).getJMSDestination();
            	//System.out.println("reading" + session.createObjectMessage(Objmsg.getObject())); 
                //TestClass s = (TestClass) Objmsg.getObject();
            	System.out.println(((ObjectMessage)queuemessage).getJMSDestination());
            	System.out.println(((ObjectMessage)queuemessage).getJMSMessageID());
               // System.out.println(((TestClass)Objmsg).getEid()); 
            	Object objectData = ((ObjectMessage)queuemessage).getObject();
                if (objectData instanceof TestClass) {
                	TestClass s1 = (TestClass) objectData;
                	System.out.println("Reading message s1: " +s1.getEid());
                }
                String objectName = Objmsg.getStringProperty("ObjectName");   
                if (objectName.equals("TestClass")) {
                	TestClass obj= (TestClass) objectData;
                	System.out.println("Reading message: " + obj.getEid());
                }
                System.out.println("Reading message: " + Objmsg.getObject());
            } else {
                System.err.println("Message is not a TextMessage");
            }
        } catch (JMSException e) {
            System.err.println("JMSException in onMessage(): " + e.toString());
            e.printStackTrace();
        } catch (Throwable t) {
            System.err.println("Exception in onMessage():" + t.getMessage());
        }
    }

}
